package anynt.environment;


import anynt.object.Agent;
import anynt.object.behaviour.HumanBehaviour;
import anynt.object.behaviour.QLearningBehaviour;


/**
 * Lambda Environment prepared for AGI conference.
 * In this environment there are a human and a QLearning that will be evaluated.
 * None of them should see each other.
 * 
 * @author Javier
 * @since 11/04/2011
 */
public class AGILambdaEnvironment extends LambdaEnvironment
{
	/**
	 * Locate agents with the subject and qLearning together
	 */
	protected void initialLocateAgents()
	{
		// Initially locate the agents
		super.initialLocateAgents();

		// Locate qLearning with the subject
		Agent subject = null;
		Agent qLearning = null;
		for (Agent agent : agents)
			if (agent.getBehaviour() instanceof HumanBehaviour)
				subject = agent;
			else if (agent.getBehaviour() instanceof QLearningBehaviour)
				qLearning = agent;

		locateAgent(qLearning, subject.getLocation().getNumber());
	}
}