package anynt.object.behaviour;


import java.util.ArrayList;

import anynt.object.Agent;
import anynt.object.RewardsGeneratorAgent;
import anynt.space.Cell;
import anynt.space.Space;


public class _QLearningAloneBehaviour extends QLearningBehaviour
{
	public _QLearningAloneBehaviour(ArrayList<Agent> agents, double learningRate, double randomExplorationDegree, double discountFactor, double initialQ)
	{
		super(agents, learningRate, randomExplorationDegree, discountFactor, initialQ);
	}


	protected String GetStateDescription(Space space)
	{
		String description = "";

		for (Cell cell : space.getCells())
		{
			for (Agent agent : agents)
			{
				if (!(agent instanceof RewardsGeneratorAgent || this.agent == agent))
					continue;

				if (cell.getAgents().contains(agent))
					description = description.concat("1");
				else
					description = description.concat("0");
			}
			description = description.concat("|");
		}
		description = description.substring(0, description.length() - 1);

		return description;
	}
}