package anynt.testEnvironments;


import java.util.Random;

import anynt.environment.Environment;
import anynt.object.Agent;
import anynt.space.Observation;
import anynt.space.SimpleObservation;


public class DiceEnvironment extends Environment
{
	private String[] observations;
	private int actualObservation;
	private int number;


	public DiceEnvironment()
	{
		super();

		actions = new int[7];
		actions[0] = 0;
		actions[1] = 1;
		actions[2] = 2;
		actions[3] = 3;
		actions[4] = 4;
		actions[5] = 5;
		actions[6] = 6;

		observations = new String[7];
		observations[0] = "No observation";
		observations[1] = "1";
		observations[2] = "2";
		observations[3] = "3";
		observations[4] = "4";
		observations[5] = "5";
		observations[6] = "6";

		number = 0;
	}


	protected Observation takeObservation()
	{
		actualObservation = new Random().nextInt(observations.length - 1) + 1;

		number = (number + actualObservation) % 6;
		if (number == 0)
			number = 6;

		return new SimpleObservation(observations[actualObservation]);
	}
	protected void prepareEnvironment()
	{
		
	}
	protected void prepareInteraction(int interactionNumber)
	{
		
	}
	protected void makeAction(Agent agent, int[] action)
	{
		agent.setReward(action[0] == number ? 1.0 : -1.0);
	}
	protected void actualize()
	{
		
	}
}