package anynt.testEnvironments;


import anynt.environment.LambdaEnvironment;
import anynt.space.Cell;
import anynt.space.Connection;


public class GoodAndEvilEnvironment extends LambdaEnvironment
{
	private static int WIDTH = 10;
	private static int HEIGHT = 10;


	public GoodAndEvilEnvironment()
	{
		actions = new int[5];
		actions[0] = 0;
		actions[1] = 1;
		actions[2] = 2;
		actions[3] = 3;
		actions[4] = 4;
	}


	public void describeEnvironment()
	{
		space.generateSpace();
		Cell[] cells = new Cell[WIDTH * HEIGHT + 1];

		for (int index = 1; index <= WIDTH * HEIGHT; index++)
		{
			cells[index] = new Cell(index);
			space.addVertex(cells[index]);
			Connection connection = new Connection(cells[index], cells[index], 0);
			space.addEdge(connection);
		}

		for (int index = 0; index < WIDTH * HEIGHT; index++)
		{
			int rightIndex = (index + 1) % WIDTH + (index / WIDTH) * WIDTH;
			int topIndex = (index + WIDTH) % (WIDTH * HEIGHT);
			int leftIndex = (index - 1 + WIDTH) % WIDTH + (index / WIDTH) * WIDTH;
			int downIndex = (index - WIDTH + WIDTH * HEIGHT) % (WIDTH * HEIGHT);

			Cell actualCell = cells[index + 1];

			space.addEdge(new Connection(actualCell, cells[rightIndex + 1], 1));
			space.addEdge(new Connection(actualCell, cells[topIndex + 1], 2));
			space.addEdge(new Connection(actualCell, cells[leftIndex + 1], 3));
			space.addEdge(new Connection(actualCell, cells[downIndex + 1], 4));
		}
	}
}