package human.AGI;


import interfaces.HumanAGITestInterface;

import java.awt.GridBagLayout;
import java.awt.Image;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import java.awt.GridBagConstraints;
import javax.swing.JTextField;
import java.awt.Dimension;
import javax.swing.JButton;
import java.awt.Insets;
import javax.swing.JLabel;


public class InstructionsPanel extends JPanel {

	private static final long serialVersionUID = 1L;


	private static int REWARDS_SIDE = 40;
	private static int SUBJECT_SIDE = 25;


	private JTextArea instructionsArea = null;
	private JTextField subjectName = null;
	private JTextArea startArea = null;
	private JButton startButton = null;
	private HumanAGITestInterface frame;
	private JLabel pos_rewards = null;


	private JLabel neutral_rewards = null;


	private JLabel neg_rewards = null;


	private JTextArea UnderstoodArea = null;


	private JLabel agent = null;


	/**
	 * This is the default constructor
	 */
	public InstructionsPanel(HumanAGITestInterface frame) {
		super();
		initialize();

		this.frame = frame;
	}


	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
		gridBagConstraints12.gridx = 0;
		gridBagConstraints12.anchor = GridBagConstraints.WEST;
		gridBagConstraints12.insets = new Insets(5, 20, 5, 0);
		gridBagConstraints12.gridy = 2;
		agent = new JLabel();
		agent.setText("You");
		agent.setIcon(new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/agent.png")).getImage().getScaledInstance(InstructionsPanel.SUBJECT_SIDE, InstructionsPanel.SUBJECT_SIDE, Image.SCALE_SMOOTH)));
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.fill = GridBagConstraints.BOTH;
		gridBagConstraints4.gridy = 5;
		gridBagConstraints4.weightx = 1.0;
		gridBagConstraints4.weighty = 1.0;
		gridBagConstraints4.anchor = GridBagConstraints.WEST;
		gridBagConstraints4.insets = new Insets(20, 20, 20, 0);
		gridBagConstraints4.gridx = 0;
		GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
		gridBagConstraints31.gridx = 0;
		gridBagConstraints31.anchor = GridBagConstraints.WEST;
		gridBagConstraints31.insets = new Insets(5, 20, 5, 0);
		gridBagConstraints31.gridy = 4;
		neg_rewards = new JLabel();
		neg_rewards.setText("Negative reward");
		neg_rewards.setIcon(new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/neg_reward.png")).getImage().getScaledInstance(InstructionsPanel.REWARDS_SIDE, InstructionsPanel.REWARDS_SIDE, Image.SCALE_SMOOTH)));
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 0;
		gridBagConstraints21.anchor = GridBagConstraints.WEST;
		gridBagConstraints21.insets = new Insets(5, 20, 5, 0);
		gridBagConstraints21.gridy = 3;
		neutral_rewards = new JLabel();
		neutral_rewards.setText("Neutral reward");
		neutral_rewards.setIcon(new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/neutral_reward.png")).getImage().getScaledInstance(InstructionsPanel.REWARDS_SIDE, InstructionsPanel.REWARDS_SIDE, Image.SCALE_SMOOTH)));
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.gridx = 0;
		gridBagConstraints11.anchor = GridBagConstraints.WEST;
		gridBagConstraints11.insets = new Insets(0, 20, 25, 0);
		gridBagConstraints11.gridy = 1;
		pos_rewards = new JLabel();
		pos_rewards.setText("Positive reward");
		pos_rewards.setIcon(new ImageIcon(new ImageIcon(getClass().getResource("/human/agi/image/pos_reward.png")).getImage().getScaledInstance(InstructionsPanel.REWARDS_SIDE, InstructionsPanel.REWARDS_SIDE, Image.SCALE_SMOOTH)));
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 0;
		gridBagConstraints3.insets = new Insets(0, 0, 100, 0);
		gridBagConstraints3.gridy = 8;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.fill = GridBagConstraints.BOTH;
		gridBagConstraints2.gridy = 7;
		gridBagConstraints2.weightx = 1.0;
		gridBagConstraints2.weighty = 1.0;
		gridBagConstraints2.insets = new Insets(20, 20, 0, 0);
		gridBagConstraints2.gridx = 0;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
		gridBagConstraints1.gridy = 6;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.anchor = GridBagConstraints.WEST;
		gridBagConstraints1.insets = new Insets(0, 20, 0, 0);
		gridBagConstraints1.gridx = 0;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 1.0;
		gridBagConstraints.insets = new Insets(20, 20, 20, 20);
		gridBagConstraints.gridx = 0;
		setSize(300, 200);
		setLayout(new GridBagLayout());
		add(getInstructionsArea(), gridBagConstraints);
		add(getSubjectName(), gridBagConstraints1);
		add(getStartArea(), gridBagConstraints2);
		add(getStartButton(), gridBagConstraints3);
		add(pos_rewards, gridBagConstraints12);
		add(neutral_rewards, gridBagConstraints21);
		add(neg_rewards, gridBagConstraints31);
		add(getUnderstoodArea(), gridBagConstraints4);
		add(agent, gridBagConstraints11);
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getInstructionsArea() {
		if (instructionsArea == null) {
			instructionsArea = new JTextArea();
			instructionsArea.setEditable(false);
			String texto = "";
			texto += "INSTRUCTIONS:\n";
			texto += "\n";
			texto += "This test will take about 25 minutes.\n";
			texto += "\n";
			texto += "Please read these instructions carefully before taking the test.\n";
			texto += "\n";
			texto += "        Speed is not relevant, so take your time to do the best you can for every move.\n";
			texto += "        The test is composed of several interactive exercises.\n";
			texto += "        Each exercise will be composed of a series of steps. The number of steps is fixed beforehand, so acting rashly can only make you score poorly.\n";
			texto += "        You are represented by a circle which is located in a cell. You can move to other cells by clicking on the accessible cells. You can also remain on the same cell by clicking on it.\n";
			texto += "        After each movement you will receive a reward. Rewards can be positive, neutral or negative.\n";
			texto += "        Your goal is to obtain as more positive rewards as possible and as few negative rewards as possible.";
			instructionsArea.setText(texto);
			instructionsArea.setBackground(getBackground());
		}
		return instructionsArea;
	}


	/**
	 * This method initializes subjectName	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSubjectName() {
		if (subjectName == null) {
			subjectName = new JTextField();
			subjectName.setPreferredSize(new Dimension(200, 20));
			subjectName.addCaretListener(new javax.swing.event.CaretListener() {
				public void caretUpdate(javax.swing.event.CaretEvent e) {
					startReady();
				}
			});
		}
		return subjectName;
	}


	/**
	 * This method initializes startArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getStartArea() {
		if (startArea == null) {
			startArea = new JTextArea();
			startArea.setText("And press START when you are ready to go.");
			startArea.setEditable(false);
			startArea.setBackground(getBackground());
		}
		return startArea;
	}


	/**
	 * This method initializes startButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getStartButton() {
		if (startButton == null) {
			startButton = new JButton();
			startButton.setText("START");
			startButton.setPreferredSize(new Dimension(200, 30));
			startButton.setEnabled(false);
			startButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					start();
				}
			});
		}
		return startButton;
	}


	private void startReady()
	{
		if (subjectName.getText().length() > 0)
			startButton.setEnabled(true);
		else
			startButton.setEnabled(false);
	}

	private void start()
	{
		frame.launchTest(subjectName.getText());
	}


	/**
	 * This method initializes ComprendidoArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getUnderstoodArea() {
		if (UnderstoodArea == null) {
			UnderstoodArea = new JTextArea();
			UnderstoodArea.setBackground(getBackground());
			UnderstoodArea.setText("If you have understood the instructions, please enter your name:");
			UnderstoodArea.setEditable(false);
		}
		return UnderstoodArea;
	}
}