package investigation;


import interfaces.InvestigationTestInterface;

import javax.swing.JPanel;
import java.awt.Rectangle;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;

import java.awt.Font;
import java.awt.Color;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JTextField;

import anynt.space.Space;


@SuppressWarnings("serial")
public class SpaceOptionsPanel extends JPanel
{
	private InvestigationTestInterface frame;
	private Space space;


	private JPanel spacePanel = null;
	private JPanel cells = null;
	private JRadioButton manualCells = null;
	private JRadioButton UDCells = null;
	private JLabel minimumUDCells = null;
	private JLabel maximumUDCells = null;
	private JComboBox minimumUDCellsCombo = null;
	private JComboBox maximumUDCellsCombo = null;
	private JComboBox manualCellsCombo = null;
	private JPanel actions = null;
	private JRadioButton manualActions = null;
	private JRadioButton UDActions = null;
	private JComboBox manualActionsCombo = null;
	private JLabel minimumUDActions = null;
	private JLabel maximumUDActions = null;
	private JComboBox minimumUDActionsCombo = null;
	private JComboBox maximumUDActionsCombo = null;
	private JPanel topology = null;
	private JRadioButton withoutRestrictions = null;
	private JRadioButton connected = null;
	private JRadioButton stronglyConnected = null;
	private JButton generate = null;
	private JLabel generatedSpace = null;
	private JTextField generatedSpaceText = null;
	private JButton agree = null;

	private String spaceDescription = null;
	private boolean changingComboValue = false;
	private JLabel agreement = null;
	private JLabel generatedCells = null;
	private JLabel generatedActions = null;
	private JTextField generatedCellsText = null;
	private JTextField generatedActionsText = null;


	/**
	 * This is the default constructor
	 */
	public SpaceOptionsPanel(InvestigationTestInterface frame, Space space)
	{
		super();

		this.frame = frame;
		this.space = space;

		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		setLayout(null);
		setBounds(new Rectangle(0, 0, 806, 527));
		add(getSpacePanel(), null);

		UDCells.doClick();
		UDActions.doClick();
		stronglyConnected.doClick();

		spaceDescription = null;
	}

	/**
	 * This method initializes space
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSpacePanel()
	{
		if (spacePanel == null)
		{
			generatedActions = new JLabel();
			generatedActions.setBounds(new Rectangle(230, 360, 145, 20));
			generatedActions.setText("Generated no. of actions:");
			generatedCells = new JLabel();
			generatedCells.setBounds(new Rectangle(15, 360, 130, 20));
			generatedCells.setText("Generated no. of cells:");
			agreement = new JLabel();
			agreement.setBounds(new Rectangle(275, 400, 230, 20));
			agreement.setEnabled(false);
			agreement.setText("Do you agree with the generated space?");
			generatedSpace = new JLabel();
			generatedSpace.setBounds(new Rectangle(15, 325, 105, 20));
			generatedSpace.setText("Generated space:");
			spacePanel = new JPanel();
			spacePanel.setLayout(null);
			spacePanel.setBorder(BorderFactory.createTitledBorder(null, "Space", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			spacePanel.setBounds(new Rectangle(15, 20, 777, 492));
			spacePanel.add(getCells(), null);
			spacePanel.add(getActions(), null);
			spacePanel.add(getTopology(), null);
			spacePanel.add(getGenerate(), null);
			spacePanel.add(generatedSpace, null);
			spacePanel.add(getGeneratedSpaceText(), null);
			spacePanel.add(getAgree(), null);
			spacePanel.add(agreement, null);
			spacePanel.add(generatedCells, null);
			spacePanel.add(generatedActions, null);
			spacePanel.add(getGeneratedCellsText(), null);
			spacePanel.add(getGeneratedActionsText(), null);
		}
		return spacePanel;
	}

	/**
	 * This method initializes cells
	 * 	
	 * @return javax.swing.JPanel
	 */
	private JPanel getCells()
	{
		if (cells == null)
		{
			maximumUDCells = new JLabel();
			maximumUDCells.setBounds(new Rectangle(165, 70, 120, 20));
			maximumUDCells.setText("Maximum no. of cells");
			minimumUDCells = new JLabel();
			minimumUDCells.setBounds(new Rectangle(165, 45, 120, 20));
			minimumUDCells.setText("Minimum no. of cells");
			cells = new JPanel();
			cells.setLayout(null);
			cells.setBorder(BorderFactory.createTitledBorder(null, "Number of cells", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			cells.setBounds(new Rectangle(15, 20, 360, 105));
			cells.add(getManualCells(), null);
			cells.add(getUDCells(), null);
			cells.add(minimumUDCells, null);
			cells.add(maximumUDCells, null);
			cells.add(getMinimumUDCellsCombo(), null);
			cells.add(getMaximumUDCellsCombo(), null);
			cells.add(getManualCellsCombo(), null);

			ButtonGroup cellsGroup = new ButtonGroup();
			cellsGroup.add(getManualCells());
			cellsGroup.add(getUDCells());
		}
		return cells;
	}

	/**
	 * This method initializes manualCells	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getManualCells()
	{
		if (manualCells == null)
		{
			manualCells = new JRadioButton();
			manualCells.setBounds(new Rectangle(15, 30, 70, 20));
			manualCells.setText("Manual");
			manualCells.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectManualCells();
				}
			});
		}
		return manualCells;
	}

	/**
	 * This method initializes UDCells	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getUDCells()
	{
		if (UDCells == null)
		{
			UDCells = new JRadioButton();
			UDCells.setBounds(new Rectangle(15, 60, 150, 20));
			UDCells.setText("Universal Distribution");
			UDCells.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectUDCells();
				}
			});
		}
		return UDCells;
	}

	/**
	 * This method initializes minimumUDCellsCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getMinimumUDCellsCombo()
	{
		if (minimumUDCellsCombo == null)
		{
			minimumUDCellsCombo = new JComboBox();
			minimumUDCellsCombo.setBounds(new Rectangle(300, 45, 45, 20));
			constructIntegerComboValues(minimumUDCellsCombo, 2, 9);
			minimumUDCellsCombo.setSelectedItem(2);
			minimumUDCellsCombo.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (!changingComboValue)
					{
						changingComboValue = true;
						changedMinimumCells();
						changingComboValue = false;
					}
				}
			});
		}
		return minimumUDCellsCombo;
	}

	/**
	 * This method initializes maximumUDCellsCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getMaximumUDCellsCombo()
	{
		if (maximumUDCellsCombo == null)
		{
			maximumUDCellsCombo = new JComboBox();
			maximumUDCellsCombo.setBounds(new Rectangle(300, 70, 45, 20));
			constructIntegerComboValues(maximumUDCellsCombo, 2, 9);
			maximumUDCellsCombo.setSelectedItem(9);
			maximumUDCellsCombo.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (!changingComboValue)
					{
						changingComboValue = true;
						changedMaximumCells();
						changingComboValue = false;
					}
				}
			});
		}
		return maximumUDCellsCombo;
	}

	/**
	 * This method initializes manualCellsCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getManualCellsCombo()
	{
		if (manualCellsCombo == null)
		{
			manualCellsCombo = new JComboBox();
			manualCellsCombo.setBounds(new Rectangle(85, 30, 45, 20));
			constructIntegerComboValues(manualCellsCombo, 2, 9);
			manualCellsCombo.setSelectedItem(2);
		}
		return manualCellsCombo;
	}

	/**
	 * This method initializes actions	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getActions()
	{
		if (actions == null)
		{
			maximumUDActions = new JLabel();
			maximumUDActions.setBounds(new Rectangle(165, 70, 135, 20));
			maximumUDActions.setText("Maximum no. of actions");
			minimumUDActions = new JLabel();
			minimumUDActions.setBounds(new Rectangle(165, 45, 135, 20));
			minimumUDActions.setText("Minimum no. of actions");
			actions = new JPanel();
			actions.setLayout(null);
			actions.setBounds(new Rectangle(390, 20, 375, 105));
			actions.setBorder(BorderFactory.createTitledBorder(null, "Number of actions", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			actions.add(getManualActions(), null);
			actions.add(getUDActions(), null);
			actions.add(getManualActionsCombo(), null);
			actions.add(minimumUDActions, null);
			actions.add(maximumUDActions, null);
			actions.add(getMinimumUDActionsCombo(), null);
			actions.add(getMaximumUDActionsCombo(), null);

			ButtonGroup actionsGroup = new ButtonGroup();
			actionsGroup.add(getManualActions());
			actionsGroup.add(getUDActions());
		}
		return actions;
	}

	/**
	 * This method initializes manualActions	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getManualActions()
	{
		if (manualActions == null)
		{
			manualActions = new JRadioButton();
			manualActions.setBounds(new Rectangle(15, 30, 70, 20));
			manualActions.setText("Manual");
			manualActions.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectManualActions();
				}
			});
		}
		return manualActions;
	}

	/**
	 * This method initializes UDActions	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getUDActions()
	{
		if (UDActions == null)
		{
			UDActions = new JRadioButton();
			UDActions.setBounds(new Rectangle(15, 60, 150, 20));
			UDActions.setText("Universal Distribution");
			UDActions.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectUDActions();
				}
			});
		}
		return UDActions;
	}

	/**
	 * This method initializes manualActionsCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getManualActionsCombo()
	{
		if (manualActionsCombo == null)
		{
			manualActionsCombo = new JComboBox();
			manualActionsCombo.setBounds(new Rectangle(85, 30, 45, 20));
			constructIntegerComboValues(manualActionsCombo, 2, 9);
			manualActionsCombo.setSelectedItem(2);
		}
		return manualActionsCombo;
	}

	/**
	 * This method initializes minimumUDActionsCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getMinimumUDActionsCombo()
	{
		if (minimumUDActionsCombo == null)
		{
			minimumUDActionsCombo = new JComboBox();
			minimumUDActionsCombo.setBounds(new Rectangle(315, 45, 45, 20));
			constructIntegerComboValues(minimumUDActionsCombo, 2, 9);
			minimumUDActionsCombo.setSelectedItem(2);
			minimumUDActionsCombo.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (!changingComboValue)
					{
						changingComboValue = true;
						changedMinimumActions();
						changingComboValue = false;
					}
				}
			});
		}
		return minimumUDActionsCombo;
	}

	/**
	 * This method initializes maximumUDActionsCombo	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getMaximumUDActionsCombo()
	{
		if (maximumUDActionsCombo == null)
		{
			maximumUDActionsCombo = new JComboBox();
			maximumUDActionsCombo.setBounds(new Rectangle(315, 70, 45, 20));
			constructIntegerComboValues(maximumUDActionsCombo, 2, 9);
			maximumUDActionsCombo.setSelectedItem(9);
			maximumUDActionsCombo.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (!changingComboValue)
					{
						changingComboValue = true;
						changedMaximumActions();
						changingComboValue = false;
					}
				}
			});
		}
		return maximumUDActionsCombo;
	}

	/**
	 * This method initializes topology	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getTopology()
	{
		if (topology == null)
		{
			topology = new JPanel();
			topology.setLayout(null);
			topology.setBounds(new Rectangle(17, 134, 205, 125));
			topology.setBorder(BorderFactory.createTitledBorder(null, "Topology", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
			topology.add(getWithoutRestrictions(), null);
			topology.add(getConnected(), null);
			topology.add(getStronglyConnected(), null);

			ButtonGroup topologyGroup = new ButtonGroup();
			topologyGroup.add(getWithoutRestrictions());
			topologyGroup.add(getConnected());
			topologyGroup.add(getStronglyConnected());
		}
		return topology;
	}

	/**
	 * This method initializes withoutRestrictions	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWithoutRestrictions()
	{
		if (withoutRestrictions == null)
		{
			withoutRestrictions = new JRadioButton();
			withoutRestrictions.setBounds(new Rectangle(15, 30, 140, 20));
			withoutRestrictions.setText("Without restrictions");
		}
		return withoutRestrictions;
	}

	/**
	 * This method initializes connected	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getConnected()
	{
		if (connected == null)
		{
			connected = new JRadioButton();
			connected.setBounds(new Rectangle(15, 60, 130, 20));
			connected.setText("Connected space");
		}
		return connected;
	}

	/**
	 * This method initializes stronglyConnected	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getStronglyConnected()
	{
		if (stronglyConnected == null)
		{
			stronglyConnected = new JRadioButton();
			stronglyConnected.setBounds(new Rectangle(15, 90, 175, 20));
			stronglyConnected.setText("Strongly connected space");
		}
		return stronglyConnected;
	}

	/**
	 * This method initializes generate	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getGenerate()
	{
		if (generate == null)
		{
			generate = new JButton();
			generate.setBounds(new Rectangle(315, 275, 150, 30));
			generate.setText("Generate space");
			generate.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					generateSpace();
				}
			});
		}
		return generate;
	}

	/**
	 * This method initializes generatedSpaceText	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getGeneratedSpaceText()
	{
		if (generatedSpaceText == null)
		{
			generatedSpaceText = new JTextField();
			generatedSpaceText.setBounds(new Rectangle(135, 325, 620, 20));
			generatedSpaceText.setEditable(false);
			generatedSpaceText.setBackground(Color.white);
			generatedSpaceText.setEnabled(true);
		}
		return generatedSpaceText;
	}

	/**
	 * This method initializes agree	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAgree()
	{
		if (agree == null)
		{
			agree = new JButton();
			agree.setBounds(new Rectangle(315, 435, 150, 30));
			agree.setEnabled(false);
			agree.setText("Agree");
			agree.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					agree();
				}
			});
		}
		return agree;
	}


	private void selectManualCells()
	{
		manualCellsCombo.setEnabled(true);
		minimumUDCells.setEnabled(false);
		maximumUDCells.setEnabled(false);
		minimumUDCellsCombo.setEnabled(false);
		maximumUDCellsCombo.setEnabled(false);
	}
	private void selectUDCells()
	{
		manualCellsCombo.setEnabled(false);
		minimumUDCells.setEnabled(true);
		maximumUDCells.setEnabled(true);
		minimumUDCellsCombo.setEnabled(true);
		maximumUDCellsCombo.setEnabled(true);
	}
	private void selectManualActions()
	{
		manualActionsCombo.setEnabled(true);
		minimumUDActions.setEnabled(false);
		maximumUDActions.setEnabled(false);
		minimumUDActionsCombo.setEnabled(false);
		maximumUDActionsCombo.setEnabled(false);
	}
	private void selectUDActions()
	{
		manualActionsCombo.setEnabled(false);
		minimumUDActions.setEnabled(true);
		maximumUDActions.setEnabled(true);
		minimumUDActionsCombo.setEnabled(true);
		maximumUDActionsCombo.setEnabled(true);
	}
	private void changedMinimumCells()
	{
		int minimumCells = (Integer) minimumUDCellsCombo.getSelectedItem();
		constructIntegerComboValues(maximumUDCellsCombo, minimumCells, 9);
	}
	private void changedMaximumCells()
	{
		int maximumCells = (Integer) maximumUDCellsCombo.getSelectedItem();
		constructIntegerComboValues(minimumUDCellsCombo, 2, maximumCells);
	}
	private void changedMinimumActions()
	{
		int minimumActions = (Integer) minimumUDActionsCombo.getSelectedItem();
		constructIntegerComboValues(maximumUDActionsCombo, minimumActions, 9);
	}
	private void changedMaximumActions()
	{
		int maximumActions = (Integer) maximumUDActionsCombo.getSelectedItem();
		constructIntegerComboValues(minimumUDActionsCombo, 2, maximumActions);
	}

 	private void constructIntegerComboValues(JComboBox combo, int startNumber, int maxNumber)
	{
		Object selectedNumber = combo.getSelectedItem();
		combo.removeAllItems();
		for (int index = startNumber; index <= maxNumber; index++)
			combo.addItem(index);
		combo.setSelectedItem(selectedNumber);
		if (combo.getSelectedIndex() < 0)
			combo.setSelectedIndex(0);
	}

	private void generateSpace()
	{
		if (manualCells.isSelected())
			space.setCellsBounds((Integer) manualCellsCombo.getSelectedItem(), (Integer) manualCellsCombo.getSelectedItem());
		else if (UDCells.isSelected())
			space.setCellsBounds((Integer) minimumUDCellsCombo.getSelectedItem(), (Integer) maximumUDCellsCombo.getSelectedItem());

		if (manualActions.isSelected())
			space.setActionsBounds((Integer) manualActionsCombo.getSelectedItem(), (Integer) manualActionsCombo.getSelectedItem());
		else if (UDActions.isSelected())
			space.setActionsBounds((Integer) minimumUDActionsCombo.getSelectedItem(), (Integer) maximumUDActionsCombo.getSelectedItem());

		if (withoutRestrictions.isSelected())
			space.generateSpace();
		else if (connected.isSelected())
			do
				space.generateSpace();
			while (!space.isConnected());
		else if (stronglyConnected.isSelected())
			do
				space.generateSpace();
			while (!space.isStrongConnected());

		spaceDescription = space.getDescription();
		generatedSpaceText.setText(spaceDescription);
		generatedCellsText.setText(space.getNumberOfCells() + "");
		generatedActionsText.setText(space.getNumberOfActions() + "");
		agreement.setEnabled(true);
		agree.setEnabled(true);
	}

	private void agree()
	{
		frame.agreeSpace();
	}

	/**
	 * This method initializes generatedCellsText	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getGeneratedCellsText()
	{
		if (generatedCellsText == null)
		{
			generatedCellsText = new JTextField();
			generatedCellsText.setBounds(new Rectangle(160, 360, 40, 20));
			generatedCellsText.setText("");
			generatedCellsText.setEditable(false);
			generatedCellsText.setBackground(Color.white);
			generatedCellsText.setEnabled(true);
		}
		return generatedCellsText;
	}

	/**
	 * This method initializes generatedActionsText	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextField getGeneratedActionsText()
	{
		if (generatedActionsText == null)
		{
			generatedActionsText = new JTextField();
			generatedActionsText.setBounds(new Rectangle(390, 360, 40, 20));
			generatedActionsText.setText("");
			generatedActionsText.setEditable(false);
			generatedActionsText.setBackground(Color.white);
			generatedActionsText.setEnabled(true);
		}
		return generatedActionsText;
	}
}