package main;

import anynt.environment.LambdaEnvironment;
import anynt.environment.settings.NoShareRewards;
import anynt.environment.settings.RewardsProvider;
import anynt.exercise.Exercise;
import anynt.exercise.settings.InteractionType;
import anynt.exercise.settings.NumberOfInteractionsInteractionType;
import anynt.exercise.settings.StepWaiting;
import anynt.exercise.settings.TimeDelayWaiting;
import anynt.object.EvaluableAgent;
import anynt.object.RewardsGeneratorAgent;
import anynt.object.behaviour.AgentBehaviour;
import anynt.object.behaviour.OracleBehaviour;
import anynt.object.behaviour.PatternBehaviour;
import anynt.object.moveController.IAgentMoveController;
import anynt.object.moveController.NumberOfMovementsMoveController;
import anynt.space.Space;
import anynt.test.InvestigationTest;
import anynt.test.Test;

//@SuppressWarnings("unused")
public class Probando
{
	public static void main(String[] args)
	{
		Test test = InvestigationTest.getTest();
		Exercise exercise = new Exercise();
		LambdaEnvironment environment = new LambdaEnvironment();
		EvaluableAgent agent = new EvaluableAgent("Agente");
		Space space = new Space();
		RewardsGeneratorAgent good = environment.getGoodAgent();
		RewardsGeneratorAgent evil = environment.getEvilAgent();

		InteractionType interactionType = new NumberOfInteractionsInteractionType(1000000);
		StepWaiting stepWaiting = new TimeDelayWaiting();
		RewardsProvider rewardsProvider = new NoShareRewards();
		exercise.setInteractionType(interactionType);
		exercise.setStepWaiting(stepWaiting);
		environment.setRewardsProvider(rewardsProvider);

		do
		{
			space.generateSpace();
		}
		while (!space.isStrongConnected() || space.getNumberOfCells() < 6);
		environment.setSpace(space);

		IAgentMoveController moveController = new NumberOfMovementsMoveController();
		AgentBehaviour behaviour = new OracleBehaviour(environment);
		agent.setKnownActions(environment.getActions());
		agent.setMoveController(moveController);
		agent.setBehaviour(behaviour);
		agent.setMaximumObservationsSaved(10);
		String patron = PatternBehaviour.generatePattern(environment.getActions(), 10);
		PatternBehaviour goodBehaviour = new PatternBehaviour(patron);
		good.setKnownActions(environment.getActions());
		good.setMoveController(moveController);
		good.setBehaviour(goodBehaviour);
		good.setMaximumObservationsSaved(10);
		PatternBehaviour evilBehaviour = goodBehaviour.clone();
		evilBehaviour.setAgent(evil);
		evil.setKnownActions(environment.getActions());
		evil.setMoveController(moveController);
		evil.setBehaviour(evilBehaviour);
		evil.setMaximumObservationsSaved(10);
		environment.addAgent(agent);
		environment.setRewardsConsumedBeforeRewardersUpdateCellRewards(true);

		exercise.setEnvironment(environment);
		exercise.setEvaluableAgent(agent);

		test.setEvaluatedAgent(agent);
		test.setExercise(exercise);
		test.start();
	}
}